#import <Foundation/Foundation.h>

@interface TestClass : NSObject
@end
@implementation TestClass
- (void) dealloc
{
	NSLog(@"%p: entering dealloc", self);

        void (^myBlock)() = ^() {
            id foo = self;
	    NSLog(@"inside myBlock, foo = %p", foo);
        };

	NSLog(@"%p: calling myBlock()", self);
	myBlock(); 
	
	NSLog(@"%p: leaving dealloc", self);
}
@end
 
int main(int argc, const char * argv[])
{    
    @autoreleasepool {
	TestClass *c = [[TestClass alloc] init]; 
    }
                
    return 0;
}
